/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * FreeImage.dll should present to use this sample
 * http://freeimage.sourceforge.net/
 *
 * Copyright 2003-2008 Grigory Filatov <gfilatov@freemail.ru>
*/

#include "FreeImage.ch"

#include "minigui.ch"

#define PROGRAM 'FreeImage Viewer Lite'
#define VERSION ' version 1.4.0'
#define COPYRIGHT ' 2003-2008 Grigory Filatov'
#define MsgAlert( c ) MsgAlert( c, "Attention" )

Static handle, nWidth, nHeight, nKoef := 1

Memvar nScrWidth, nScrHeight

Function Main( fname )
LOCAL nLen := 0, aDesk := GetDesktopArea()
PRIVATE nScrWidth := aDesk[3], nScrHeight := aDesk[4]

   default fname := "test.tif"

   IF !FILE('FreeImage.Dll')
      MsgAlert("Can't found the FreeImage.Dll")
      Return Nil
   ENDIF

   fi_Initialise()

   SET CENTURY ON
   SET DATE GERMAN

   DEFINE WINDOW Form_Main ;
	AT 0,0 ;
	WIDTH 400 HEIGHT 400 ;
	TITLE PROGRAM ;
	MAIN ;
	ON INIT {|| handle := FI_Load( FIF_TIFF, fname, TIFF_DEFAULT ), ;
		nWidth := FI_GetWidth( handle ), nHeight := FI_GetHeight( handle ), ;
		Form_Main.Width  := nWidth + GetBorderWidth() + 4, ;
		Form_Main.Height := nHeight + GetTitleHeight() + 4, ;
		PaintWindow() } ;
	ON PAINT PaintWindow() ;
	ON RELEASE fi_Deinitialise() ;
	FONT 'MS Sans Serif' SIZE 9

   END WINDOW

   CENTER WINDOW Form_Main

   ACTIVATE WINDOW Form_Main

Return Nil

#translate Application.Handle => _HMG_SYSDATA [ 181 ]

Static Function PaintWindow()
Local pps, hDC

   IF handle == Nil
      Return -1
   ENDIF

   InvalidateRect( Application.Handle, 0 )

   pps := DefinePaintStru()
   hDC := BeginPaint( Application.Handle, pps )

   FI_WinDraw( handle, hDC, 0, 0, Round( nHeight * nKoef, 0 ), Round( nWidth * nKoef, 0 ) )

   EndPaint( Application.Handle, pps )

Return 0

Static Function MsgAbout()
return MsgInfo( padc(PROGRAM + VERSION, 40) + CRLF + ;
	padc("Copyright " + Chr(169) + COPYRIGHT, 40) + CRLF + CRLF + ;
	hb_compiler() + CRLF + version() + CRLF + ;
	Left(MiniGuiVersion(), 36) + CRLF + ;
	"FreeImage.dll version: "+FI_GetVersion() + CRLF + CRLF + ;
	padc("This program is Freeware!", 40), "About..." )


#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

#ifdef __XHARBOUR__
#define HB_STORNI( n, x, y ) hb_storni( n, x, y )
#else
#define HB_STORNI( n, x, y ) hb_storvni( n, x, y )
#endif


HB_FUNC ( DEFINEPAINTSTRU )
{
   PAINTSTRUCT *pps = (PAINTSTRUCT*) hb_xgrab( sizeof( PAINTSTRUCT ) );
   hb_retnl( (LONG) pps );
}

HB_FUNC ( BEGINPAINT )
{
   PAINTSTRUCT *pps = (PAINTSTRUCT*) hb_parnl( 2 );
   HDC hDC = BeginPaint( (HWND) hb_parnl( 1 ), pps );
   hb_retnl( (LONG) hDC );
}

HB_FUNC ( ENDPAINT )
{
   PAINTSTRUCT *pps = (PAINTSTRUCT*) hb_parnl( 2 );
   EndPaint( (HWND) hb_parnl( 1 ), pps );
   hb_xfree( pps );
}

HB_FUNC ( GETDESKTOPAREA ) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_reta(4);
	HB_STORNI((INT) rect.top, -1, 1);
	HB_STORNI((INT) rect.left, -1, 2);
	HB_STORNI((INT) rect.right - rect.left, -1, 3);
	HB_STORNI((INT) rect.bottom - rect.top, -1, 4);
}
 
#pragma ENDDUMP
